# $Id: sqwebmail.spec.in,v 1.81 2005/03/01 02:57:43 mrsam Exp $
#
# Copyright 1998 - 2005 Double Precision, Inc.  See COPYING for
# distribution information.


#
#  Need to version-upgrade RH builds due to different directory locations.
#

%define is_not_mandrake %(test ! -e /etc/mandrake-release && echo 1 || echo 0)

%if %is_not_mandrake
%define courier_release %(release="`rpm -q --queryformat='.%{VERSION}' redhat-release 2>/dev/null`" ; if test $? != 0 ; then release="`rpm -q --queryformat='.%{VERSION}' fedora-release 2>/dev/null`" ; if test $? != 0 ; then release="" ; fi ; fi ; echo "$release")
%else
%define courier_release mdk
%endif

%define _missing_doc_files_terminate_build 1
%define _unpackaged_files_terminate_build 1

%{expand:%%define apachedir %(if test -d /home/httpd ; then echo /home/httpd ; else echo /var/www ; fi)}

%define	cgibindir		%{apachedir}/cgi-bin
%define imagedir		%{apachedir}/html/webmail
%define	imageurl		/webmail

%define	cacheowner		bin
%define cachedir		%{_localstatedir}/webmail-logincache

%{expand:%%define initdir %(if test -d /etc/init.d/. ; then echo /etc/init.d ; else echo /etc/rc.d/init.d ; fi)}

Summary: SqWebMail - Maildir Webmail CGI client.
Name: sqwebmail
Version: 5.0.1
Release: 1%{courier_release}
Copyright: GPL
Packager: %{PACKAGER}
Group: Applications/Mail
Source: http://download.sourceforge.net/courier/sqwebmail-5.0.1.tar.bz2
Url: http://www.inter7.com/sqwebmail/
BuildRoot: %{_tmppath}/sqwebmail-install
Requires: /sbin/chkconfig gnupg >= 1.0.5 vixie-cron expect
%if %is_not_mandrake
Requires: %{cgibindir}
%endif
Obsoletes: %{name}-ldap
Obsoletes: %{name}-mysql
Obsoletes: %{name}-pgsql

BuildPreReq: rpm >= 4.0.2 fileutils grep perl gnupg >= 1.0.5
BuildPreReq: courier-authlib-devel >= 0.55

%description
SqWebMail is a Webmail CGI for Maildir mailboxes.

%define _prefix /usr/lib/sqwebmail
%define _sysconfdir %{_prefix}/etc
%define _mandir %{_prefix}/man

%define scriptdir %{_datadir}/sqwebmail
%define htmldir %{_datadir}/sqwebmail/html

%prep
%setup -q
%configure \
	--enable-cgibindir=%{cgibindir} \
	--enable-imagedir=%{imagedir} \
	--enable-imageurl=%{imageurl} \
	--with-cachedir=%{cachedir} \
	--with-cacheowner=%{cacheowner} \
	%{?xflags: %{xflags}}


#
#  --sysconfdir needed for RH 7.x
#

%build
LANG=C
export LANG
%{__make}
%{__make} check
%install
LANG=C
export LANG
%{__rm} -rf $RPM_BUILD_ROOT
%{__make} install DESTDIR=$RPM_BUILD_ROOT
%{__mkdir} -p $RPM_BUILD_ROOT/etc/pam.d
%{__install} -m 0444 sqwebmail/webmail.authpam $RPM_BUILD_ROOT/etc/pam.d/webmail
%{__install} -m 0444 sqwebmail/webmail.authpam $RPM_BUILD_ROOT/etc/pam.d/calendar

%{__rm} $RPM_BUILD_ROOT%{htmldir}/en || exit 1
# Drop the soft link -> en_us, this is taken care of by post script.

%{__mkdir} -p $RPM_BUILD_ROOT/etc/cron.hourly
%{__cat} >$RPM_BUILD_ROOT/etc/cron.hourly/sqwebmail-cron-cleancache <<EOF
#!/bin/sh

su - %{cacheowner} -s /bin/sh -c %{scriptdir}/cleancache.pl
EOF

#
# Red Hat /etc/profile.d scripts
#

%{__mkdir} -p $RPM_BUILD_ROOT/etc/profile.d
%{__cat} >$RPM_BUILD_ROOT/etc/profile.d/sqwebmail.sh <<EOF
if echo "\$MANPATH" | tr ':' '\012' | fgrep -qx %{_mandir}
then
	:
else
	MANPATH="%{_mandir}:\$MANPATH"
	export MANPATH

	if test -w /etc
	then
		PATH="%{_sbindir}:\$PATH"
	fi
	export PATH
fi
EOF

%{__cat} >$RPM_BUILD_ROOT/etc/profile.d/sqwebmail.csh <<EOF

if ( \$?MANPATH ) then
	true
else
	setenv MANPATH ""
endif

echo "\$MANPATH" | tr ':' '\012' | fgrep -qx %{_mandir}

if ( \$? ) then
	true
else
	setenv MANPATH "%{_mandir}:\$MANPATH"
	test -w /etc
	if ( \$? ) then
		true
        else
		setenv PATH "%{_sbindir}:\$PATH"
	endif
endif
EOF

#
# Red Hat init.d file
#

%{__mkdir} -p $RPM_BUILD_ROOT%{initdir}

%{__cat} >$RPM_BUILD_ROOT%{initdir}/sqwebmail <<EOF
#!/bin/sh
#
# chkconfig: 2345 50 50
# description: Start authdaemon daemon for SqWebMail
#
#
#

case "\$1" in
start)
        cd /
	touch /var/lock/subsys/sqwebmail

	echo -n "Starting SqWebMail:"

	%{_libexecdir}/sqwebmaild.rc start
	echo " sqwebmaild"
	;;
stop)
	echo -n "Stopping SqWebMail:"
	%{_libexecdir}/sqwebmaild.rc stop
	echo " sqwebmaild"
	;;
restart)
	\$0 stop
	\$0 start
	;;
reload)
	echo -n "Restarting SqWebMail:"
	%{_libexecdir}/sqwebmaild.rc reload
	echo " done"
        ;;
esac
exit 0
EOF

%{__cp} sysconftool $RPM_BUILD_ROOT%{scriptdir}/sysconftool
%{__cat} >$RPM_BUILD_ROOT%{scriptdir}/sysconftool-rpmupgrade <<EOF
#!/bin/sh

for f in \$* "."
do
	if test \$f = "."
	then
		continue
	fi

	base=\`echo \$f | sed 's/\\.dist\$//'\`
	if test -f \$base.dist -a ! -f \$base
	then
		%{__cp} -pr \$base.dist \$base
	fi
done
EOF

chmod 555 $RPM_BUILD_ROOT%{scriptdir}/sysconftool-rpmupgrade

%{__cp} pcp/README.html pcp_README.html

. pcp/uids
echo '%attr(-, ' "$localcacheowner, $mailgroup) $calendardir" >filelist

(
courierauthconfig --configfiles >configtmp || exit 1
. configtmp
echo '%attr(-, '"$mailuser, $mailgroup" ') %{_libexecdir}' >>filelist
) || exit 1

%post

test -d %{htmldir}/en || ln -fs en-us %{htmldir}/en

if test -f %{initdir}/sqwebmail
then
	/sbin/chkconfig --del sqwebmail
	/sbin/chkconfig --add sqwebmail
fi

%{scriptdir}/sysconftool %{_sysconfdir}/*.dist >/dev/null

%preun

%{_libexecdir}/sqwebmaild.rc stop

%triggerpostun -- sqwebmail

test ! -x %{scriptdir}/sysconftool-rpmupgrade || %{scriptdir}/sysconftool-rpmupgrade %{_sysconfdir}/*.dist

test -f /etc/pam.d/webmail || test ! -f /etc/pam.d/webmail.rpmnew || mv -f /etc/pam.d/webmail.rpmnew /etc/pam.d/webmail
test -f /etc/pam.d/calendar || test ! -f /etc/pam.d/calendar.rpmnew || mv -f /etc/pam.d/calendar.rpmnew /etc/pam.d/calendar

%postun
test -d %{htmldir}/en || %{__rm} -f %{htmldir}/en

%files -f filelist
%defattr(-, root, bin)
%dir %{_prefix}
%if "%{_prefix}" != "%{_exec_prefix}"
%dir %{_exec_prefix}
%endif

%attr(555, root, root) %{scriptdir}
%dir %{_sysconfdir}
%{_sysconfdir}/*.dist

%{cgibindir}/*
%{imagedir}
%{_sbindir}
%{_mandir}

%dir %{_localstatedir}
%attr(555, root, root) %{initdir}/*

%attr(700, %{cacheowner}, bin) %{cachedir}
%attr(644, root, root) %config(noreplace) /etc/pam.d/*

%attr(755, bin, bin) /etc/cron.hourly/sqwebmail-cron-cleancache
%attr(755, bin, bin) /etc/profile.d/sqwebmail.sh
%attr(755, bin, bin) /etc/profile.d/sqwebmail.csh

%attr(-, bin, bin) %doc AUTHORS sqwebmail/BUGS COPYING INSTALL INSTALL.vchkpw NEWS README sqwebmail/SECURITY sqwebmail/TODO gpglib/README.html
%attr(-, bin, bin) %doc sqwebmail/BUGS.html INSTALL.html NEWS README.html sqwebmail/SECURITY.html sqwebmail/TODO.html sqwebmail/ChangeLog pcp_README.html
%attr(-, bin, bin) %doc maildir/README*.html


%clean
%{__rm} -rf $RPM_BUILD_ROOT
